/**
 *******************************************************************************
 * @file    main.c
 *
 * @brief   Main program body.
 *
 * @author  DPM
 *
 * @version V1.0.0
 *
 * @date    2024-5-6
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "main.h"
#include "dpm32m0xx.h"
#include "dpm32m0xx_eval.h"
#include "systick.h"
#include <stdio.h>

/**
  * @addtogroup DPM32M08X_LibSamples
  * @{
  */

/**
  * @addtogroup DAC
  * @{
  */

/**
  * @addtogroup DAC_Output
  * @{
  */

/* Private typedef --------------------------------------------------------------*/
GPIO_InitTypeStruct DAC_GPIOInitStruct;
DAC_InitTypeStruct DAC_InitType;
/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/

/* Private functions ------------------------------------------------------------*/

/**
  * @brief  The program entry function.
  * @retval int
  */
int main(void)
{
  /* Configure the system clock */
  SystemClockInit();
  /* Configure the system tick */
  SystickInit();

  /* LED Init */
  EVAL_LedInit(LED1);

  /* Print Uart Init */
  EVAL_ComInit();
  
  /********************* Operation  *********************/
  /* Enable clock */
  RCC_Unlock();
  RCC_AHBPeriphClockCmd(RCC_AHB_PERIPH_GPIO, ENABLE);
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_DAC, ENABLE);
  RCC_Lock();
  /* Init DAC GPIO */
  GPIO_StructInit(&DAC_GPIOInitStruct);
  DAC_GPIOInitStruct.GPIO_Pin = GPIO_PIN_11;
  DAC_GPIOInitStruct.GPIO_PuPd = GPIO_PUPD_NOPULL;
  DAC_GPIOInitStruct.GPIO_OType = GPIO_OTYPE_PP;
  DAC_GPIOInitStruct.GPIO_Mode = GPIO_MODE_ANALOG;
  DAC_GPIOInitStruct.GPIO_Speed = GPIO_SPEED_HIGH;
  GPIO_Init(GPIOD, &DAC_GPIOInitStruct);
  GPIO_AnaAFConfig(GPIOD, GPIO_PIN_11, GPIO_ANA_AF_0);
  
  /* Configure DAC */
  DAC_StructInit(&DAC_InitType);
  DAC_InitType.DAC_Vref = DAC_VREF_AVDD;
  DAC_InitType.DAC_Data = 0;
  DAC_Init(&DAC_InitType);
  DAC_Cmd(ENABLE);

  uint32_t ledTime = 0;
  uint16_t DacOutData = 0;
  uint32_t DacOutTime = 0;
  /* Infinite loop */
  while(1)
  {
    /* Runing led toggle */
    if(ledTime < GetTick())
    {
      ledTime = GetTick() + 1000;
      EVAL_LedToggle(LED1);
    }
    /* DAC output */
    if(DacOutTime < GetTick())
    {
      DacOutTime = GetTick() + 1;
      DAC_SetData(DacOutData > 4095 ? 0 : DacOutData++);
    }
  }
}

/* retarget the C library printf function to the usart */
int fputc(int ch, FILE *f)
{
  UART_SendData(EVAL_COM0, (uint8_t)ch);

  while(RESET == UART_GetIntFlagStatus(EVAL_COM0, UART_INT_FLAG_TXE));

  return ch;
}


/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
